


def data_header(filename):
    """
    Create the header for the file.

    Parameters:
        filename (str): the path to the data file

    Output:
        header (list of strs): the header containing column names
    """
    header = []
    return header


def data_as_list_of_lists(filename):
    """
    Read in the data as a list of lists.

    Parameters:
        filename (str): the path to the data file

    Output: 
    dataset (list of lists): the dataset
    """
    dataset = []
    return dataset

def head(header, dataset, k):
    """
    Print the first k rows of the dataset underneath the header.

    Parameters:
        header (list of strs): the header containing column names
        dataset (list of lists): the dataset
        k (int): the number of rows to print

    Output:
        None
    """
    print(header)
    for row in dataset[0:k]:
        print(row)
    return None



def get_column(dataset, idx):
    """
    For a dataset in list-of-lists form, return a list containing the indexed value of
    each row.

    Parameters:
        dataset (list of lists): the input data
        idx (int): an integer index corresponding to a column in the data

    Returns:
        column (list): a single list containing a value from each row
    """
    return [row[idx] for row in dataset]

def is_numeric(column):
    """
    For a dataset and a column index, return True if the column is numeric
     and False if it is not.

    HINT: we can assume that each column is of one type, i.e., we can consider
    only the first element of the column.

    Parameters:
        column (list): a list of values corresponding to a column in a dataset

    Returns:
        answer (bool): True if the column is numeric, False otherwise
    """
    if isinstance(column[0], (int, float)):
        return True
    else:
        return False


def print_columns(header):
    """
    Take a header and print the names *and* indices of each column.

    Hint: Use range(len(header))

    Parameters:
        header (list of strings): the names of each column in the dataset

    Returns:
        None
    """
    for col_idx in range(len(header)):
        print(col_idx, header[col_idx])
    return None


def filter_numerical(dataset, col_index, min_value, max_value):
    """
    Filters the dataset by a numerical column and return the specified subset

    Parameters:
        dataset (list of lists): the input data
        col_index (int): an integer index corresponding to a column in the data
        max/min_values (float): the minimum and maximum values to filter on

    Returns:
        filtered_data (list of lists): the filtered data, with the same column structure as dataset
    """
    return [row for row in dataset if row[col_index] >= min_value and row[col_index] <= max_value]


def filter_categorical(dataset, col_index, categories):
    """
    Filters the dataset by a categorical column and return the specified subset

    Parameters:
        dataset (list of lists): the input data
        col_index (int): an integer index corresponding to a column in the data
        categories (list): a list of strings representing categories to include

    Returns:
        filtered_data (list of lists): the filtered data, with the same column structure as dataset
    """
    return [row for row in dataset if row[col_index] in categories]
